// モジュールの読み込み
const unique = require('./unique.js').unique;

// 実行
const arrSrc = [
	{name: 'cat'},
	{name: 'cat'},
	{name: 'cat', age: 1},
	{name: 'cat', age: 2}
];

// 各要素を普通に文字列化すると「[object Object]」になり、
// 全て同じと見なされます
const arrDst0 = unique(arrSrc);
console.log(JSON.stringify(arrDst0, null, '  '));

console.log('\n----------\n');

// 文字列化する関数を別途用意すると、正しくユニーク化されます
const arrDst1 = unique(arrSrc, JSON.stringify);
console.log(JSON.stringify(arrDst1, null, '  '));
